From: Phillip Wood <phillip.wood123@gmail.com>
To: Christophe Poucet via GitGitGadget <gitgitgadget@gmail.com>,
git@vger.kernel.org
Cc: Christophe Poucet <christophe.poucet@gmail.com>
Subject: Re: [PATCH 00/10] Add the Git Change command
Date: Tue, 4 Oct 2022 15:24:48 +0100 [thread overview]
Message-ID: <2a1c3861-c752-4f40-59d3-803a62cd1bc2@dunelm.org.uk> (raw)
In-Reply-To: <pull.1356.git.1663959324.gitgitgadget@gmail.com>
Hi Chris
On 23/09/2022 19:55, Christophe Poucet via GitGitGadget wrote:
> I'm reviving the original git evolve work that was started by
> sxenos@google.com
> (https://public-inbox.org/git/20190215043105.163688-1-sxenos@google.com/)
>
> This work is intended to make it easier to deal with stacked changes.
>
> The following set of patches introduces the design doc on the evolve command
> as well as the basics of the git change command.
Our test suite can be a little tricky to get started with and I was impatient to
check the basic functionality of these patches so I've written some simple
example tests for the change command and a couple of fixups to make them pass.
Best Wishes
Phillip
---- >8 ----
From a7c38d0f388e4d8a1f3debcc3069a7fb43084eda Mon Sep 17 00:00:00 2001
From: Phillip Wood <phillip.wood@dunelm.org.uk>
Date: Tue, 4 Oct 2022 15:12:36 +0100
Subject: [PATCH 1/3] fixup! evolve: add support for writing metacommits
---
metacommit.c | 2 +-
1 file changed, 1 insertion(+), 1 deletion(-)
diff --git a/metacommit.c b/metacommit.c
index d2b859a4d3..8f970fa104 100644
--- a/metacommit.c
+++ b/metacommit.c
@@ -296,7 +296,7 @@ int record_metacommit_withresult(
if (override_change) {
string_list_clear(changes, 0);
overridden_head = get_change_head(chtable, override_change);
- if (!overridden_head) {
+ if (overridden_head) {
/* This is an existing change */
old_head = &overridden_head->head;
if (!force) {
--
2.37.3.947.g1b8ba4da7f.dirty
From cc7e8ba0b1a90268ced85d3f0c91aed49f2246d6 Mon Sep 17 00:00:00 2001
From: Phillip Wood <phillip.wood@dunelm.org.uk>
Date: Tue, 4 Oct 2022 15:15:32 +0100
Subject: [PATCH 2/3] fixup! evolve: implement the git change command
---
t/t9999-changes.sh | 126 +++++++++++++++++++++++++++++++++++++++++++++
1 file changed, 126 insertions(+)
create mode 100755 t/t9999-changes.sh
diff --git a/t/t9999-changes.sh b/t/t9999-changes.sh
new file mode 100755
index 0000000000..9e58925b23
--- /dev/null
+++ b/t/t9999-changes.sh
@@ -0,0 +1,126 @@
+#!/bin/sh
+
+test_description='git change - low level meta-commit management'
+
+. ./test-lib.sh
+
+. "$TEST_DIRECTORY"/lib-rebase.sh
+
+test_expect_success 'setup commits and meta-commits' '
+ for c in one two three
+ do
+ test_commit $c &&
+ git change update --content $c >actual 2>err &&
+ echo "Created change metas/$c" >expect &&
+ test_cmp expect actual &&
+ test_must_be_empty err &&
+ test_cmp_rev refs/metas/$c $c || return 1
+ done
+'
+
+# Check a meta-commit has the correct parents Call with the object
+# name of the meta-commit followed by pairs of type and parent
+check_meta_commit () {
+ name=$1
+ shift
+ while test $# -gt 0
+ do
+ printf '%s %s\n' $1 $(git rev-parse --verify $2)
+ shift
+ shift
+ done | sort >expect
+ git cat-file commit $name >metacommit &&
+ # commit body should consist of parent-type
+ types="$(sed -n '/^$/ {
+ :loop
+ n
+ s/^parent-type //
+ p
+ b loop
+ }' metacommit)" &&
+ while read key value
+ do
+ # TODO: don't sort the first parent
+ if test "$key" = "parent"
+ then
+ type="${types%% *}"
+ test -n "$type" || return 1
+ printf '%s %s\n' $type $value
+ types="${types#?}"
+ types="${types# }"
+ elif test "$key" = "tree"
+ then
+ test_cmp_rev "$value" $EMPTY_TREE || return 1
+ elif test -z "$key"
+ then
+ # only parse commit headers
+ break
+ fi
+ done <metacommit >actual-unsorted &&
+ test -z "$types" &&
+ sort >actual <actual-unsorted &&
+ test_cmp expect actual
+}
+
+test_expect_success 'update meta-commits after rebase' '
+ (
+ set_fake_editor &&
+ FAKE_AMEND=edited &&
+ FAKE_LINES="reword 1 pick 2 fixup 3" &&
+ export FAKE_AMEND FAKE_LINES &&
+ git rebase -i --root
+ ) &&
+
+ # update meta-commits
+ git change update --replace tags/one --content HEAD~1 >out 2>err &&
+ echo "Updated change metas/one" >expect &&
+ test_cmp expect out &&
+ test_must_be_empty err &&
+ git change update --replace tags/two --content HEAD@{2} &&
+ oid=$(git rev-parse --verify metas/two) &&
+ git change update --replace HEAD@{2} --replace tags/three \
+ --content HEAD &&
+
+ # check meta-commits
+ check_meta_commit metas/one c HEAD~1 r tags/one &&
+ check_meta_commit $oid c HEAD@{2} r tags/two &&
+ # NB this checks that "git change update" uses the meta-commit ($oid)
+ # corresponding to the replaces commit (HEAD@2 above) given on the
+ # commandline.
+ check_meta_commit metas/two c HEAD r $oid r tags/three &&
+ check_meta_commit metas/three c HEAD r $oid r tags/three
+'
+
+reset_meta_commits () {
+ for c in one two three
+ do
+ echo "update refs/metas/$c refs/tags/$c^0"
+ done | git update-ref --stdin
+}
+
+test_expect_success 'override change name' '
+ # TODO: builtin/change.c expects --change to be the full refname,
+ # ideally it would prepend refs/metas to the string given by the
+ # user.
+ git change update --change refs/metas/another-one --content one &&
+ test_cmp_rev metas/another-one one
+'
+
+test_expect_success 'non-fast forward meta-commit update refused' '
+ test_must_fail git change update --change refs/metas/one --content two \
+ >out 2>err &&
+ echo "error: non-fast-forward update to ${SQ}refs/metas/one${SQ}" \
+ >expect &&
+ test_cmp expect err &&
+ test_must_be_empty out
+'
+
+test_expect_success 'forced non-fast forward update succeeds' '
+ git change update --change refs/metas/one --content two --force \
+ >out 2>err &&
+ echo "Updated change metas/one" >expect &&
+ test_cmp expect out &&
+ test_must_be_empty err
+'
+
+test_done
--
2.37.3.947.g1b8ba4da7f.dirty
From 7784f253fa799dd11fcbc81fe815fb387af52d97 Mon Sep 17 00:00:00 2001
From: Phillip Wood <phillip.wood@dunelm.org.uk>
Date: Tue, 4 Oct 2022 15:16:05 +0100
Subject: [PATCH 3/3] fixup! evolve: add the git change list command
---
builtin/change.c | 16 +++++-----------
t/t9999-changes.sh | 11 +++++++++++
2 files changed, 16 insertions(+), 11 deletions(-)
diff --git a/builtin/change.c b/builtin/change.c
index 07d029d82d..888ef648fa 100644
--- a/builtin/change.c
+++ b/builtin/change.c
@@ -34,9 +34,8 @@ static int change_list(int argc, const char **argv, const char* prefix)
OPT_END()
};
struct ref_filter filter;
- /* TODO: See below
struct ref_sorting *sorting;
- struct string_list sorting_options = STRING_LIST_INIT_DUP; */
+ struct string_list sorting_options = STRING_LIST_INIT_DUP;
struct ref_format format = REF_FORMAT_INIT;
struct ref_array array;
int i;
@@ -53,19 +52,15 @@ static int change_list(int argc, const char **argv, const char* prefix)
filter_refs(&array, &filter, FILTER_REFS_CHANGES);
- /* TODO: This causes a crash. It sets one of the atom_value handlers to
- * something invalid, which causes a crash later when we call
- * show_ref_array_item. Figure out why this happens and put back the sorting.
- *
- * sorting = ref_sorting_options(&sorting_options);
- * ref_array_sort(sorting, &array); */
-
if (!format.format)
format.format = "%(refname:lstrip=1)";
if (verify_ref_format(&format))
die(_("unable to parse format string"));
+ sorting = ref_sorting_options(&sorting_options);
+ ref_array_sort(sorting, &array);
+
for (i = 0; i < array.nr; i++) {
struct strbuf output = STRBUF_INIT;
struct strbuf err = STRBUF_INIT;
@@ -79,8 +74,7 @@ static int change_list(int argc, const char **argv, const char* prefix)
}
ref_array_clear(&array);
- /* TODO: see above
- ref_sorting_release(sorting); */
+ ref_sorting_release(sorting);
return 0;
}
diff --git a/t/t9999-changes.sh b/t/t9999-changes.sh
index 9e58925b23..9312eba86d 100755
--- a/t/t9999-changes.sh
+++ b/t/t9999-changes.sh
@@ -123,4 +123,15 @@ test_expect_success 'forced non-fast forward update succeeds' '
test_must_be_empty err
'
+test_expect_success 'list changes' '
+ cat >expect <<-\EOF &&
+ metas/another-one
+ metas/one
+ metas/three
+ metas/two
+ EOF
+ git change list >actual &&
+ test_cmp expect actual
+'
+
test_done
--
2.37.3.947.g1b8ba4da7f.dirty
next prev parent reply other threads:[~2022-10-04 14:25 UTC|newest]
Thread overview: 66+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-09-23 18:55 [PATCH 00/10] Add the Git Change command Christophe Poucet via GitGitGadget
2022-09-23 18:55 ` [PATCH 01/10] technical doc: add a design doc for the evolve command Stefan Xenos via GitGitGadget
2022-09-23 19:59 ` Jerry Zhang
2022-09-28 21:26 ` Junio C Hamano
2022-09-28 22:20 ` Junio C Hamano
2022-09-29 9:17 ` Phillip Wood
2022-09-29 19:57 ` Jonathan Tan
2022-09-23 18:55 ` [PATCH 02/10] sha1-array: implement oid_array_readonly_contains Chris Poucet via GitGitGadget
2022-09-26 13:08 ` Phillip Wood
2022-09-23 18:55 ` [PATCH 03/10] ref-filter: add the metas namespace to ref-filter Chris Poucet via GitGitGadget
2022-09-26 13:13 ` Phillip Wood
2022-10-04 9:50 ` Chris P
2022-09-23 18:55 ` [PATCH 04/10] evolve: add support for parsing metacommits Stefan Xenos via GitGitGadget
2022-09-26 13:27 ` Phillip Wood
2022-10-04 11:21 ` Chris P
2022-10-04 14:10 ` Phillip Wood
2022-09-23 18:55 ` [PATCH 05/10] evolve: add the change-table structure Stefan Xenos via GitGitGadget
2022-09-27 13:27 ` Phillip Wood
2022-09-27 13:50 ` Ævar Arnfjörð Bjarmason
2022-09-27 14:13 ` Phillip Wood
2022-09-27 15:28 ` Ævar Arnfjörð Bjarmason
2022-09-28 14:33 ` Phillip Wood
2022-09-28 15:14 ` Ævar Arnfjörð Bjarmason
2022-09-28 15:59 ` Junio C Hamano
2022-09-27 14:18 ` Phillip Wood
2022-10-04 14:48 ` Chris P
2022-09-23 18:55 ` [PATCH 06/10] evolve: add support for writing metacommits Stefan Xenos via GitGitGadget
2022-09-28 14:27 ` Phillip Wood
2022-10-05 9:40 ` Chris P
2022-10-05 11:09 ` Phillip Wood
2022-09-23 18:55 ` [PATCH 07/10] evolve: implement the git change command Stefan Xenos via GitGitGadget
2022-09-25 9:10 ` Phillip Wood
2022-09-26 8:23 ` Ævar Arnfjörð Bjarmason
2022-09-26 8:25 ` Ævar Arnfjörð Bjarmason
2022-10-05 12:30 ` Chris P
2022-09-23 18:55 ` [PATCH 08/10] evolve: add the git change list command Stefan Xenos via GitGitGadget
2022-09-23 18:55 ` [PATCH 09/10] evolve: add delete command Chris Poucet via GitGitGadget
2022-09-26 8:38 ` Ævar Arnfjörð Bjarmason
2022-09-26 9:10 ` Chris Poucet
2022-09-23 18:55 ` [PATCH 10/10] evolve: add documentation for `git change` Chris Poucet via GitGitGadget
2022-09-25 8:41 ` Phillip Wood
2022-09-25 8:39 ` [PATCH 00/10] Add the Git Change command Phillip Wood
2022-10-04 9:33 ` Chris P
2022-10-04 14:24 ` Phillip Wood [this message]
2022-10-04 15:19 ` Chris P
2022-10-04 15:55 ` Chris P
2022-10-04 16:00 ` Phillip Wood
2022-10-04 15:57 ` Phillip Wood
2022-10-05 14:59 ` [PATCH v2 00/10] RFC: Git Evolve / Change Christophe Poucet via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 01/10] technical doc: add a design doc for the evolve command Stefan Xenos via GitGitGadget
2022-10-05 15:16 ` Chris Poucet
2022-10-06 20:53 ` Glen Choo
2022-10-10 19:35 ` Victoria Dye
2022-10-11 8:59 ` Phillip Wood
2022-10-11 16:59 ` Victoria Dye
2022-10-12 19:19 ` Phillip Wood
2022-10-05 14:59 ` [PATCH v2 02/10] sha1-array: implement oid_array_readonly_contains Chris Poucet via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 03/10] ref-filter: add the metas namespace to ref-filter Chris Poucet via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 04/10] evolve: add support for parsing metacommits Stefan Xenos via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 05/10] evolve: add the change-table structure Stefan Xenos via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 06/10] evolve: add support for writing metacommits Stefan Xenos via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 07/10] evolve: implement the git change command Stefan Xenos via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 08/10] evolve: add delete command Chris Poucet via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 09/10] evolve: add documentation for `git change` Chris Poucet via GitGitGadget
2022-10-05 14:59 ` [PATCH v2 10/10] evolve: add tests for the git-change command Chris Poucet via GitGitGadget
2022-10-10 9:23 ` [PATCH v2 00/10] RFC: Git Evolve / Change Phillip Wood
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: http://vger.kernel.org/majordomo-info.html
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=2a1c3861-c752-4f40-59d3-803a62cd1bc2@dunelm.org.uk \
--to=phillip.wood123@gmail.com \
--cc=christophe.poucet@gmail.com \
--cc=git@vger.kernel.org \
--cc=gitgitgadget@gmail.com \
--cc=phillip.wood@dunelm.org.uk \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://80x24.org/mirrors/git.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).